
o		equ	2			; 0=solid line
						; 1=blitter fill line
lev		equ	40
workplane	equ	$70000

BWAIT		macro
		tst	(a6)
		btst	#6,(a6)
		bne.s	*-4
		endm


j:		lea	$dff002,a6
		move	#$4000,$09a-2(a6)
		bsr.s	init_line


		moveq	#0,d0
		moveq	#0,d2
		moveq	#0,d1
		moveq	#20,d3
		moveq	#20-1,d4
.loop:
		movem.l	d0-d4,-(sp)
		bsr.s	drawline
		movem.l	(sp)+,d0-d4

		addq	#2,d0
		add	#16,d2
		dbra	d4,.loop

		BWAIT
		move	#$c000,$09a-2(a6)
		moveq	#0,d0
		rts

;-----------------------------------------------------------------------------
;- Init fill line.. Call this once for whole drawing session..
;-----------------------------------------------------------------------------
init_line:	BWAIT
		moveq	#-1,d0
		move.l	d0,$044-2(a6)
		move.l	#$ffff8000,$072-2(a6)	;bdat
		moveq	#lev,d0
		move	d0,$060-2(a6)		;cmod
		move	d0,$066-2(a6)		;dmod
no_line:	rts

;-----------------------------------------------------------------------------
;- Line must always be from top to bottom! else kabooom!!
;- A6 must be $dff002
;-----------------------------------------------------------------------------
drawline:	;d0=stx d1=sty d2=enx d3=eny
		;uses d0-d4/a0-a1

		sub	d1,d3			;
		subq	#1,d3
		bmi.s	no_line			;this replaces fill_pixel
		
		lea	$052-2(a6),a1
		lea	workplane,a0
		move	d1,d4
		mulu	#lev,d4
		add	d4,a0	
		move	d0,d4
		lsr	#3,d4
		add	d4,a0

		moveq	#0,d4
		sub	d0,d2
		bge.s	xposit
		addq	#2,d4			;octant 2,3,4,5
		neg	d2
xposit:		cmp	d2,d3
		blt.s	yless
		addq	#4,d4
		exg	d2,d3
yless:		add	d3,d3
		ror	#4,d0
		and	#$f000,d0
		or	#$0b4a,d0
		swap	d0
		move	d3,d1
		swap	d3
		sub	d2,d1
		bge.s	sign
		addq	#8,d4
sign:		move	oct(pc,d4.w),d0
		move	d1,d3
		sub	d2,d3
		lsl	#6,d2
		add	#$0042,d2

		BWAIT

		move.l	d3,$062-2(a6)
		move	d1,(a1)+		;$dff052
		move.l	d0,$040-2(a6)
;		move	#$8000,$074-2(a6)
		move.l	a0,$048-2(a6)
		move.l	a0,(a1)+		;$dff054
		move	d2,(a1)+		;$dff058
		rts

oct:		dc.w	$11+o,$15+o,$1+o,$9+o	;octant codes
		dc.w	$51+o,$55+o,$41+o,$49+o	;octant codes


