;Lousy intro for Fun???  (c) 1992 Mr.Spiv of StoneWare SoftWorks/(Morque?)
;Not another absolute one... v1.6
;Assembled with DevPac3.02b or AsmOne1.01 or greater
;
;About this intro... Works in both NTSC and PAL, even the music is played
;correctly. It's not necessary to crunch this intro into absolute address
;b'cos code, data etc are divided into several sections that take care of
;memory allocation automatically. Anyway if absolute address is needed then
;use cruncher which understands relocatible programs (like Stc3.11b, Defjam
;or DoubleAction...). $60000 would be nice place...
;But I would prefer PowerPacker or Imploder, just to make more compatible
;with all Amiga models (tested on a2000c and a3000).
;
;Text must be written as in the example. 20 chars per row and always 10 rows
;must be presented. No tabs (use spaces instead). Give the number of pages
;in MaxPage variable just above first page.
;
;If you are good colordesigner go ahead and make your own colortables for
;fading. Look the example, it shouldn't be too hard for even people who
;actually can't code. Just leave the InitTable stay as it is. Number of
;colortables is given in MaxCol variable.
;
;Although I gave this source for you it doesn't mean it's public. It's only
;for those who need it! (anyway there aren't any hard routines ;^)
;I hope you like this short hack... and remember to give me the credits...?

lev=		44

BWAITR		MACRO
		moveq	#6,\1
		btst	\1,(a6)
		btst	\1,(a6)
		bne.s	*-2
		ENDM

BWAIT		MACRO
		btst	\1,(a6)
		btst	\1,(a6)
		bne.s	*-2
		ENDM

;--------------	some systemfunctions
oldopenlibrary=	-408
closelibrary=	-414
disable=	-120
enable=		-126
forbid=		-132
permit=		-138
openresource=	-498
ableicr=	-18

;-------------------------------------------------
;main code - some init stuff
;-------------------------------------------------
		section	main,code

j:		bra.s	cont

		dc.b	"  Howdy banana! Yees Mr.Spiv is back with 'The "
		dc.b	"Mother of all Cubes'...  Codes hacked together "
		dc.b	"on 2. March -92.  "
		even

cont:		sub.l	a6,a6
		clr.l	(a6)+
		move.l	(a6),a6
		jsr	forbid(a6)
		lea	v,a5

;--------------	system level init stuff... yach!
		lea	gfxbase-v(a5),a2
		lea	gfxlib-v(a5),a1
		jsr	oldopenlibrary(a6)
		move.l	d0,(a2)+		;gfxbase
		beq	open_error

		lea	ciabresource-v(a5),a1	;ciab interrupts
		jsr	openresource(a6)
		move.l	d0,ciabbase-v(a5)
		beq	ciab_error
		move.l	d0,a6
		moveq	#$7f,d0
		jsr	ableicr(a6)
		or.b	d0,ciab-v(a5)

;--------------	setup interrupts & dmas etc
		lea	$dff002,a6
		move	#$7fff,d2
		move.l	$01c-2(a6),d1
		move	(a6),d1
		or.l	d1,(a2)+		;intena,dmacon
		move.l	$6c.w,(a2)+		;level3
		move	d2,$09a-2(a6)
		BWAITR	d1
		move	d2,$096-2(a6)

		lea	$bfd100,a0		;motor off - all drives
		move.b	#$81,(a0)
		st	(a0)

;--------------	do rest of setup - call init routines
		jsr	init_music
		bsr.s	draw_chess
		bsr	init_colors

		lea	copperlist0-v(a5),a0
		move.l	a0,$080-2(a6)
		move	d0,$088-2(a6)
		move	#$83e0,$096-2(a6)
		lea	verticalblank(pc),a0
		move.l	a0,$6c.w
		move	#$c020,$09a-2(a6)

		bsr	main

;--------------	exit stuff - restore system ------
exit_stuff:	lea	restore-v(a5),a2
		move	#$7fff,d1
		move	d1,$09a-2(a6)
		BWAITR	d0
		move	d1,$096-2(a6)
		jsr	end_music
		move.l	-(a2),$6c.w
		move.l	gfxbase-v(a5),a1
		move.l	38(a1),$080-2(a6)
		move	d0,$088-2(a6)
		move	-(a2),$096-2(a6)
		move	-(a2),$09a-2(a6)

		move.l	ciabbase-v(a5),a6
		move.b	ciab-v(a5),d0
		jsr	ableicr(a6)
ciab_error:
		move.l	$04.w,a6
		move.l	-(a2),a1
		jsr	closelibrary(a6)
open_error:	jsr	permit(a6)
		moveq	#0,d0
		rts


;-------------------------------------------------
;initializon subroutines
;-------------------------------------------------
draw_chess:	move.l	chessmask-v(a5),a0
		moveq	#-1,d0
		moveq	#lev/2-1,d1
cmaskloop:	move	d0,(a0)+
		dbf	d1,cmaskloop

		move.l	chessgfx-v(a5),a0
		clr.b	d0

		moveq	#4-1,d1
dc_loop1:	moveq	#8-1,d2
dc_loop2:	moveq	#lev/2,d3
dcf_loop:	move	d0,(a0)+
		dbf	d3,dcf_loop
		dbf	d2,dc_loop2
		not	d0
		dbf	d1,dc_loop1

;--------------	set all 10 bitplane pointers - d0=plane
set_planes:	move	#$4000,$09a-2(a6)
		moveq	#lev,d6
		movem.l	showchess-v(a5),d0-d5
		exg	d0,d1
		exg	d2,d3
		exg	d4,d5
		movem.l	d0-d5,showchess-v(a5)
		move.l	d2,d3
		add.l	d6,d3
		moveq	#8-1,d7
		lea	plane_addr-v(a5),a0
		lea	chess_addr-v(a5),a1

sp_loop0:	move.l	(a0)+,a2
		move	d2,4(a2)
		swap	d2
		move	d2,(a2)
		addq	#8,a2
		move	d3,4(a2)
		swap	d3
		move	d3,(a2)
		swap	d2
		swap	d3

		moveq	#2-1,d1
sp_loop1:	move.l	(a1)+,a2
		move	d0,4(a2)
		swap	d0
		move	d0,(a2)
		swap	d0
		dbf	d1,sp_loop1
		dbf	d7,sp_loop0

		add.l	#32*lev*2,d2
		move.l	d2,d3
		add.l	d6,d3
		move.l	(a0)+,a2		;first
		move	d2,4(a2)
		swap	d2
		move	d2,(a2)
		addq	#8,a2
		move	d3,4(a2)
		swap	d3
		move	d3,(a2)

		move.l	(a0)+,a2
		move	d4,4(a2)
		swap	d4
		move	d4,(a2)
		move	#$c000,$09a-2(a6)
		rts

;--------------	initialize copper colors
init_colors:	lea	color_addr-v(a5),a0
		move	#bcol1,d0
		move	#bcol2,d1
		moveq	#9-1,d2
ic_loop0:	move.l	(a0)+,a1
		moveq	#3-1,d3
ic_loop1:	move	d1,12(a1)
		move	d0,(a1)
		addq	#4,a1
		dbf	d3,ic_loop1
		dbf	d2,ic_loop0

		bsr	cf_end
		moveq	#-1,d0
		move	d0,(a0)
		move	d0,-(a0)
		clr.b	fadewait-v(a5)
		rts

;-------------------------------------------------
;verticalblank interrupt
;-------------------------------------------------
verticalblank:	move.l	d0,-(sp)
		st	ready-v(a5)
		not.b	switch-v(a5)
		move.b	(a5),d0			;clock
		subq.b	#1,d0
		bpl.s	clock_ok
		moveq	#7,d0
clock_ok:	move.b	d0,(a5)			;clock
		move.l	(sp)+,d0
		move	#$0070,$09c-2(a6)
		rte

;-------------------------------------------------
;--------------	clear plane - call before blitt_cubes
clear_scr:	BWAITR	d0
		move.l	#$01000000,$040-2(a6)
		clr.l	$064-2(a6)
		move.l	workscr-v(a5),$054-2(a6)
		move	#$2016,$058-2(a6)	;64*44*2
japois:		rts

;-------------------------------------------------
;-------------------------------------------------
;main loop and such things
;-------------------------------------------------
;-------------------------------------------------
;
main:		tst.b	ready-v(a5)
		beq.s	main
		clr.b	ready-v(a5)

		bsr	set_planes
		bsr.s	clear_scr
		subq.b	#1,fadewait-v(a5)
		bpl.s	no_fading
		tst.b	(a5)			;clock
		bne.s	no_fading
		bsr	cube_fader
		
no_fading:	tst.b	switch-v(a5)
		bne.s	not_yet
		tst.b	exit-v(a5)
		beq.s	not_yet
		subq	#1,cubecountx-v(a5)
		bmi.s	japois
		
not_yet:	bsr	blitt_cubes
		bsr.s	blitt_chess
		bsr	blitt_text

		btst	#6,$bfe001
		beq.s	space
		btst	#2,$016-2(a6)
		bne.s	main
space:		st	exit-v(a5)
		bra.s	main

;-------------------------------------------------
;more subroutines
;-------------------------------------------------
;--------------	scroll chess plane
blitt_chess:	movem	xchess-v(a5),d0/d1
		addq.b	#1,d0
		subq.b	#1,d1
		movem	d0/d1,xchess-v(a5)
		moveq	#$0f,d3
		and	d3,d0
		ror	#4,d0
		addq	#2,d0
		and	d3,d1
		mulu	#lev+2,d1

		move.l	chessgfx-v(a5),a1
		 lea	-2(a1),a2		;a2=mask
		move.l	workchess-v(a5),a3
		add	#lev*16*2-lev,a3	;a3=destination
		add	#(lev+2)*16-2,a1	;a1=gfx
		add	d1,a1
		move.l	a3,d2			;d2=dest

		moveq	#-1,d1
		lea	$040-2(a6),a0
		BWAITR	d3
		move.l	#$002a0000,$060-2(a6)
		move.l	#$ffd2002a,$064-2(a6)
		move	#$0fca,(a0)+		;dff040
		move	d0,(a0)+		;dff042
		move.l	d1,(a0)+		;dff044
		movem.l	d2/a1-a3,(a0)		;dff048->54
		move	#$0417,$058-2(a6)	;dff058

		rts

;-------------------------------------------------
;--------------	blitt bunch of cubes (1 to 11)
blitt_cubes:	lea	sine_table(pc),a0
		lea	precube-v(a5),a1
		move.l	workscr-v(a5),a2
		move	cubecountx-v(a5),d7
		moveq	#$7f,d5
		moveq	#-1,d0
		BWAITR	d6

		move	#$09f0,$040-2(a6)
		move.l	d0,$044-2(a6)
		move	#$0028,$066-2(a6)

;--------------	cube blitting loop -
bc_loop0:	moveq	#0,d1
		move	cubevaihe-v(a5),d1
		move.l	d1,d0
		addq	#1,d1
		and	d5,d1
		move	d1,cubevaihe-v(a5)

		move	cubewave-v(a5),d3
		move	d3,d2
		add.b	cubeadd1-v(a5),d3
		move	d3,cubewave-v(a5)

bc_loop1:	move.l	d0,-(sp)
		lsl	#8,d0
		add.l	a1,d0			;d0=cubegfx

		moveq	#0,d1
		move.b	0(a0,d3.w),d1
		add.b	cubeadd2-v(a5),d3
		mulu	#2*lev,d1
		add.l	a2,d1			;d1=place in plane
		
		BWAIT	d6
		movem.l	d0/d1,$050-2(a6)
		move	#$1002,$058-2(a6)
		move.l	(sp)+,d0
		add	cubeadd3-v(a5),d0
		and.l	d5,d0
		addq	#4,a2
		dbf	d7,bc_loop1
		rts


;-------------------------------------------------
;--------------	cube fader - handler
cube_fader:	clr.b	fadewait-v(a5)
		lea	phasetable-v(a5),a3
		lea	color_addr-v(a5),a4
		move	colorcount-v(a5),d0
		move	d0,d1
		muls	#112,d0
		lea	colortable(pc),a0
		move.l	a0,a1
		add	d0,a0			;source colors
		add	#112,d0
		cmp	#maxcol*112,d0
		blo.s	cf_range
		moveq	#0,d0
cf_range:	add	d0,a1

		lea	2+color0-v(a5),a2
		moveq	#2-1,d0
		move	phasetable-v(a5),d1
		bsr.s	fader

		moveq	#9-1,d7
		moveq	#0,d6
cf_loop0:	move.l	(a4)+,a2
		move	(a3)+,d1
		cmp	#16*16,d1
		beq.s	cf_next
		add	#16,d1
		moveq	#6-1,d0
		bsr.s	fader

		move	d1,-2(a3)
		addq	#1,d6
		tst	(a3)
		bmi.s	cf_skip
		cmp	#16,d1
		beq.s	cf_skip
		bra.s	cf_cont
cf_next:	moveq	#6*2,d0
		add	d0,a0
		add	d0,a1
cf_cont:	dbf	d7,cf_loop0
cf_skip:	tst	d6
		beq.s	cf_end
		rts

cf_end:		lea	phasetable-v(a5),a0
		moveq	#10-1,d0
cf_loop1:	clr	(a0)+
		dbf	d0,cf_loop1
		addq	#2,a0
		move	(a0),d0
		addq	#1,d0
		cmp	#maxcol,d0
		blo.s	cf_in_range
		moveq	#0,d0
cf_in_range:	move	d0,(a0)
		move.b	#50,fadewait-v(a5)
		rts

;--------------	colorfader -
;d0=number of colors-1
;d1=phase
;a0=source colors
;a1=dest colors
;a2=copperlist

fader:
floop0:		moveq	#$f,d2
		move	(a0)+,d3
		move	(a1)+,d4
		movem	d3/d4,-(sp)
		and	d2,d3
		and	d2,d4
		sub	d3,d4
fok0:		muls	d1,d4
		asr	#8,d4
		add	d4,d3

		movem	(sp),d4/d5
		lsl	#4,d2
		and	d2,d4
		and	d2,d5
		sub	d4,d5
fok1:		muls	d1,d5
		asr.l	#8,d5
		add	d4,d5
		and	d2,d5
		add	d5,d3

		move	(sp)+,d4
		move	(sp)+,d5
		lsl	#4,d2
		and	d2,d4
		and	d2,d5
		sub	d4,d5
fok2:		muls	d1,d5
		asr.l	#8,d5
		add	d4,d5
		and	d2,d5
		add	d5,d3

		move	d3,(a2)
		addq	#4,a2
		dbf	d0,floop0	;ef
text_out:	rts

;-------------------------------------------------
;--------------	blitt_text - text output routine
blitt_text:	subq	#1,textwait-v(a5)
		bpl.s	text_out
		clr	textwait-v(a5)

;--------------	blitt fonts - slow routine -------
ok_text:	lea	textphase-v(a5),a3
		lea	text(pc),a4
		lea	fonts-v(a5),a1
		move.l	a1,d4
		move.l	worktext-v(a5),a0
		add	#2*lev*24+2,a0
		move	textpage-v(a5),d0
		mulu	#20*10,d0
		add	d0,a4			;find page
		lea	$050-2(a6),a1

		BWAITR	d5
		move.l	#$09f00000,$040-2(a6)
		move	#$ffff,$046-2(a6)
		move.l	#$001e0056,$064-2(a6)

		moveq	#20-1,d7
		moveq	#0,d6
bt_loop0:	move	(a3)+,d1
		cmp	#17,d1
		beq.s	bt_next

		movem.l	a0/a4,-(sp)
		bsr.s	blitt_fonts
		move.l	(sp)+,a0
		move.l	(sp)+,a4

		addq	#1,d1
		addq	#1,d6
		move	d1,-2(a3)
		tst	(a3)
		bmi.s	bt_skip
		subq	#1,d1
		beq.s	bt_skip
bt_next:	addq	#2,a0			;dest
		addq	#1,a4			;text
bt_cont:	dbf	d7,bt_loop0
bt_skip:	tst	d6
		beq.s	bt_end
		rts

bt_end:		lea	textphase-v(a5),a0
		moveq	#20/2-1,d0
bt_loop1:	clr.l	(a0)+
		dbf	d0,bt_loop1
		addq	#2,a0
		move	(a0),d0
		addq	#1,d0
		cmp	#maxpage-1,d0
		bls.s	more_pages
		moveq	#0,d0
more_pages:	move	d0,(a0)
		move	#5*50,textwait-v(a5)
		rts

masktable:	dc.w	$8000,$c000,$e000,$f000,$f800,$fc00,$fe00,$ff00
		dc.w	$ff80,$ffc0,$ffe0,$fff0,$fff8,$fffc,$fffe,$ffff
		dc.w	$ffff

blitt_fonts:	BWAIT	d5
		move	d1,d0
		add	d0,d0
		move	masktable(pc,d0.w),$044-2(a6)
		moveq	#10-1,d0		;num_row
bf_loop0:	moveq	#0,d2
		move.b	(a4),d2
		move.b	fonttable-32(pc,d2.w),d2
		beq.s	bf_skip
		move	d2,d3
		lsr	#5,d2
		mulu	#14*32,d2
		and	#$001e,d3
		add	d3,d2
bf_skip:	add.l	d4,d2			;d4=fontaddr
		BWAIT	d5
		movem.l	d2/a0,(a1)		;$dff050
		move	#$0341,$058-2(a6)	;size 15*2
		add	#20,a4			;font next row
		add	#lev*20*2,a0		;dest next row
		dbf	d0,bf_loop0
		rts

;--------------	font table - these fonts are valid
fonttable:	dc.b	0			; space
		dc.b	43*2			; !
		dc.b	0
		dc.b	0
		dc.b	0
		dc.b	0
		dc.b	0
		dc.b	45*2			; '
		dc.b	29*2			; (
		dc.b	30*2			; )
		dc.b	47*2			; *
		dc.b	41*2			; +
		dc.b	28*2			; ,
		dc.b	42*2			; -
		dc.b	27*2			; .
		dc.b	0
		dc.b	31*2			; 0
		dc.b	32*2			; 1
		dc.b	33*2			; 2
		dc.b	34*2			; 3
		dc.b	35*2			; 4
		dc.b	36*2			; 5
		dc.b	37*2			; 6
		dc.b	38*2			; 7
		dc.b	39*2			; 8
		dc.b	40*2			; 9
		dc.b	44*2			; :
		dc.b	0
		dc.b	0
		dc.b	0
		dc.b	0
		dc.b	0
		dc.b	46*2			; @
		dc.b	1*2			; A
		dc.b	2*2			; B
		dc.b	3*2			; C
		dc.b	4*2			; D
		dc.b	5*2			; E
		dc.b	6*2			; F
		dc.b	7*2			; G
		dc.b	8*2			; H
		dc.b	9*2			; I
		dc.b	10*2			; J
		dc.b	11*2			; K
		dc.b	12*2			; L
		dc.b	13*2			; M
		dc.b	14*2			; N
		dc.b	15*2			; O
		dc.b	16*2			; P
		dc.b	17*2			; Q
		dc.b	18*2			; R
		dc.b	19*2			; S
		dc.b	20*2			; T
		dc.b	21*2			; U
		dc.b	22*2			; V
		dc.b	23*2			; W
		dc.b	24*2			; X
		dc.b	25*2			; Y
		dc.b	26*2			; Z
		even

;---------------------------------------------
maxcol=		8				;number of colortables
bcol1=		$bcc				;background color1
bcol2=		$899				;background color2
;--------------	colortables - 
inittable:	dc.w	bcol1,bcol2
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2	;1.
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2	;2.
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2	;3.
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2	;4.
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2
		dc.w	bcol1,bcol1,bcol1,bcol2,bcol2,bcol2

colortable:	dc.w	bcol1,bcol2
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5

		dc.w	bcol1,bcol2
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa

		dc.w	bcol1,bcol2
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c
		dc.w	$56b,$67c,$78d,$45a,$56b,$67c

		dc.w	bcol1,bcol2
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a

		dc.w	bcol1,bcol2
		dc.w	$944,$a55,$b66,$833,$944,$a55
		dc.w	$944,$a55,$b66,$833,$944,$a55
		dc.w	$944,$a55,$b66,$833,$944,$a55
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$394,$4a5,$5b6,$283,$394,$4a5
		dc.w	$45b,$56c,$67d,$34a,$45b,$56c
		dc.w	$45b,$56c,$67d,$34a,$45b,$56c
		dc.w	$45b,$56c,$67d,$34a,$45b,$56c

		dc.w	bcol1,bcol2
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$944,$a55,$b66,$833,$944,$a55
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$884,$995,$aa6,$773,$884,$995
		dc.w	$494,$5a5,$6b6,$383,$494,$5a5
		dc.w	$399,$4aa,$5bb,$288,$399,$4aa
		dc.w	$35b,$46c,$57d,$24a,$35b,$46c
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$944,$a55,$b66,$833,$944,$a55

		dc.w	bcol1,bcol2
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$944,$a55,$b66,$833,$944,$a55
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$884,$995,$aa6,$773,$884,$995
		dc.w	$494,$5a5,$6b6,$383,$494,$5a5
		dc.w	$499,$5aa,$6bb,$388,$499,$5aa
		dc.w	$35b,$46c,$57d,$249,$35a,$46b
		dc.w	$949,$a5a,$b6b,$838,$949,$a5a
		dc.w	$944,$a55,$b66,$833,$944,$a55

		dc.w	bcol1,bcol2
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72
		dc.w	$962,$a72,$b82,$852,$962,$a72

;-------------------------------------------------
;--------------	sinetable for waves --------------
sine_table:
	dc.b $10,$10,$10,$11,$11,$11,$12,$12,$13,$13,$13,$14,$14,$15,$15,$15
	dc.b $16,$16,$16,$17,$17,$17,$18,$18,$18,$19,$19,$19,$1A,$1A,$1A,$1B
	dc.b $1B,$1B,$1B,$1C,$1C,$1C,$1C,$1D,$1D,$1D,$1D,$1D,$1E,$1E,$1E,$1E
	dc.b $1E,$1E,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F
	dc.b $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1E
	dc.b $1E,$1E,$1E,$1E,$1E,$1D,$1D,$1D,$1D,$1D,$1C,$1C,$1C,$1C,$1B,$1B
	dc.b $1B,$1B,$1A,$1A,$1A,$19,$19,$19,$18,$18,$18,$17,$17,$17,$16,$16
	dc.b $16,$15,$15,$14,$14,$14,$13,$13,$13,$12,$12,$11,$11,$11,$10,$10
	dc.b $10,$10,$10,$0F,$0F,$0E,$0E,$0E,$0D,$0D,$0D,$0C,$0C,$0B,$0B,$0B
	dc.b $0A,$0A,$0A,$09,$09,$09,$08,$08,$08,$07,$07,$07,$06,$06,$06,$05
	dc.b $05,$05,$05,$04,$04,$04,$04,$03,$03,$03,$03,$03,$02,$02,$02,$02
	dc.b $02,$02,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
	dc.b $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$02
	dc.b $02,$02,$02,$02,$02,$03,$03,$03,$03,$03,$04,$04,$04,$04,$05,$05
	dc.b $05,$06,$06,$06,$06,$07,$07,$07,$08,$08,$08,$09,$09,$09,$0A,$0A
	dc.b $0A,$0B,$0B,$0C,$0C,$0C,$0D,$0D,$0D,$0E,$0E,$0F,$0F,$0F,$10,$10

;-------------------------------------------------
maxpage=10
;--------------	texts to output - every screen 20*10 chars
;			 01234567890123456789
text:
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"     ATTENTION!     "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "

		DC.B	"                    "
		DC.B	"   * STONEWARE! *   "
		DC.B	"        AND         "
		DC.B	"     * MORQUE *     "
		DC.B	"                    "
		DC.B	"  PROUDLY PRESENTS  "
		DC.B	"                    "
		DC.B	"*STONECRACKER V4.01*"
		DC.B	"                    "
		DC.B	"                    "

		DC.B	" ** STONECRACKER ** "
		DC.B	"                    "
		DC.B	"THE FASTEST CRUNCHER"
		DC.B	"     ON AMIGA!!     "
		DC.B	"SUPPORT FOR COMMAND,"
		DC.B	"  DATA OR ABSOLUTE  "
		DC.B	"       FILES.       "
		DC.B	" DECRUNCH ALL THREE "
		DC.B	"     FILETYPES.     "
		DC.B	"                    "

		DC.B	" CAN WRITE FILES TO "
		DC.B	"      TRACKS.       "
		DC.B	"  COMPACT AND FAST  "
		DC.B	"    DECRUNCHERS!    "
		DC.B	"3D LOOK,REQTOOLS AND"
		DC.B	" KS 2.04 COMPATIBLE "
		DC.B	" MORE THAN EASY TO  "
		DC.B	"        USE!        "
		DC.B	"                    "
		DC.B	"   * LOVE IT!! *    "

		DC.B	"                    "
		DC.B	"FOR SWAPPING CONTACT"
		DC.B	"                    "
		DC.B	"  * HOT * MORQUE *  "
		DC.B	"                    "
		DC.B	"      PL 176        "
		DC.B	"   11101 RIIHIMAKI  "
		DC.B	"      FINLAND       "
		DC.B	"                    "
		DC.B	"                    "

		DC.B	"                    "
		DC.B	" * INTRO CREDITS! * "
		DC.B	"                    "
		DC.B	"   CODES: MR.SPIV   "
		DC.B	"   COLORS: LANCER   "
		DC.B	"SONG CALLED *RECOVER"
		DC.B	"THE SONICS* FROM THE"
		DC.B	"SONIC ARRAGER DISK. "
		DC.B	"                    "
		DC.B	" NICE FADINGS, EH.. "

		DC.B	"MR.SPIV SENDS GREETS"
		DC.B	"TO FOLLOWING PEOPLE:"
		DC.B	"                    "
		DC.B	"   PSYKIC @ DECAY   "
		DC.B	"   DAXER @ ECLIPSE  "
		DC.B	" CENTURION @ TRYGON "
		DC.B	" MAGICIAN @ TRYGON  "
		DC.B	"    ZEROX @ IRIS    "
		DC.B	" BAROQUE @ FREELANCE"
		DC.B	"CYBERSONIC @ ANARCHY"

		DC.B	"CORTO @ ALLIANCE DES"
		DC.B	" MIC DAIR @ COMPLEX "
		DC.B	"  UNREAL @ UTOPIA   "
		DC.B	" TCD @ FUTURE MIRROR"
		DC.B	"JAWBREAKER @ OFFENCE"
		DC.B	"   SYNADEX @ RIFT   "
		DC.B	"   ELF CO @ RIFT    "
		DC.B	"  CANCER @ QUADRIGA "
		DC.B	" PYTHON @ BYTERAPERS"
		DC.B	"   DAMIEN @ AURORA  "

		DC.B	"    SPIV @ INFECT   "
		DC.B	" SPLIT @ BALANCE DK "
		DC.B	"  ALBIN @ EREMATION "
		DC.B	"   DARXON @ MORQUE  "
		DC.B	"    HOT @ MORQUE    "
		DC.B	"   CHUCKY @ ADONIS  "
		DC.B	"AND ALSO HELLOS TO: "
		DC.B	" MINDPHASER - JACKAL"
		DC.B	" EXTERM - OLD FART  "
		DC.B	" YADO AND THE REST! "

		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"                    "
		DC.B	"           CLICK... "

		even



;-------------------------------------------------
;pal/ntsc music player - player from sonic arr.
;-------------------------------------------------
		section	module,code_c

;-------------- interrupts for replay routine
init_music:	movem.l	d0-a6,-(sp)
		lea	level6(pc),a0
		move.l	$78.w,(a0)
		bsr	music
		moveq	#0,d0
		bsr	music+12

		lea	$dff006,a6
		move	#$4000,$09a-6(a6)
		lea	musicserver(pc),a0
		move.l	a0,$78.w

		moveq	#$37,d1			;pal
		moveq	#$6b,d2
ntsc1:		cmp.b	#$ff,(a6)
		bne.s	ntsc1
ntsc2:		cmp.b	#$20,(a6)
		bne.s	ntsc2
		move	$004-6(a6),d0
		lsr	#1,d0
		bcs.s	pal
		moveq	#-12,d2			;ntsc
pal:		lea	$bfdd00,a1
		move.b	#$02,(a1)
		move.b	d2,$600-$d00(a1)
		move.b	d1,$700-$d00(a1)
		move.b	#$82,(a1)
		move.b	#$11,$f00-$d00(a1)
		move.l	#$e0002000,$09a-6(a6)
		movem.l	(sp)+,d0-a6
		rts

;-------------- stop music dma & interrupts
end_music:	move.l	a0,-(sp)
		move.l	#$20002000,$dff09a
		lea	$bfdd00,a0
		move.b	#$02,(a0)
		clr.b	$100(a0)
		clr.b	$200(a0)
		move.l	level6(pc),$78.w
		bsr.s	music+16
		move.l	(sp)+,a0
		rts

;-------------- music interrupt server
musicserver:	move.l	d0,-(sp)
		tst.b	$bfdd00
		bsr.s	music+24
		move.l	(sp)+,d0
		move	#$2000,$09c-2(a6)
		rte

level6:		dc.l	0
		incdir	dh0:snow2/
music:		incbin	"recover_the_sonics.pc"

;-------------------------------------------------
;variables area
;-------------------------------------------------
		section	vari_apple,data_c

v:
clock:		dc.b	0
ready:		dc.b	0
switch:		dc.b	0
exit:		dc.b	0
fadewait:	dc.b	0
texttask:	dc.b	0
gfxlib:		dc.b	"graphics.library",0
ciabresource:	dc.b	"ciab.resource",0
ciab:		dc.b	$80
		even
ciabbase:	dc.l	0
textwait:	dc.w	0

f_step:		dc.w	0

cubevaihe:	dc.w	0
cubecountx:	dc.w	11-1
cubewave:	dc.w	0
cubeadd1:	dc.b	4			;wave speed
cubeadd2:	dc.b	17			;wave step
cubeadd3:	dc.w	10			;for cubes
xchess:		dc.w	0
ychess:		dc.w	0

chessmask:	dc.l	chess_mask
chessmaskend:
chessgfx:	dc.l	chess_gfx
chessgfxend:
showchess:	dc.l	chess_plane1
workchess:	dc.l	chess_plane2
showscr:	dc.l	cube_plane1
workscr:	dc.l	cube_plane2
showtext:	dc.l	text_plane
worktext:	dc.l	text_plane+lev

gfxbase:	dc.l	0
intena:		dc.w	$8000
dmacon:		dc.w	$8000
level3:		dc.l	0
restore:

phasetable:	dcb.w	10,0
		dc.w	-1
colorcount:	dc.w	-1
textphase:	dcb.w	20,0
		dc.w	-1
textpage:	dc.w	0

plane_addr:	dc.l	scr0+6,scr1+6,scr2+6,scr3+6,scr4+6
		dc.l	scr5+6,scr6+6,scr7+6,scr_first+6,scr_text+2
color_addr:	dc.l	first_col+2
		dc.l	s0col+2,s1col+2,s2col+2,s3col+2,s4col+2
		dc.l	s5col+2,s6col+2,s7col+2
chess_addr:	dc.l	chess_scr0+2,chess_scr1+6,chess_scr2+2,chess_scr3+6
		dc.l	chess_scr4+2,chess_scr5+6,chess_scr6+2,chess_scr7+6
		dc.l	chess_scr8+2,chess_scr9+6,chess_scr10+2,chess_scr11+6
		dc.l	chess_scr12+2,chess_scr13+6,chess_scr14+2,chess_scr15+6

;--------------	copperlist
copperlist0:	dc.l	$008e1871,$009006d1,$00920030,$009400d8
		dc.l	$01020000,$01040024,$0108002c,$010a002c
		dc.l	$01006200
sprites0:	dc.l	$01200000,$01220000,$01240000,$01260000
sprites2:	dc.l	$01280000,$012a0000,$012c0000,$012e0000
		dc.l	$01300000,$01320000,$01340000,$01360000
		dc.l	$01380000,$013a0000,$013c0000,$013e0000

color0:		dc.w	$0180,bcol1,$01a0,bcol2	;background&chessplane

scr_first:	dc.l	$1701fffe
		dc.l	$00e80000,$00ea0000,$00ec0000,$00ee0000
first_col:	dc.l	$01880a0a,$01900c0c,$01980e0e
		dc.l	$01a80808,$01b00a0a,$01b80c0c
scr_text:	dc.l	$00f40000,$00f60000
scr0:		dc.l	$1801fffe	;main & visible copperlist
		dc.l	$00e00000,$00e20000,$00e40000,$00e60000
chess_scr0:	dc.l	$00f00000,$00f20000
s0col:		dc.l	$018200aa,$018400cc,$018600ee
		dc.l	$01a20088,$01a400aa,$01a600cc
chess_scr1:	dc.l	$2801fffe
		dc.l	$00f00000,$00f20000
scr1:		dc.l	$3801fffe
		dc.l	$00e80000,$00ea0000,$00ec0000,$00ee0000
chess_scr2:	dc.l	$00f00000,$00f20000
s1col:		dc.l	$01880aa0,$01900cc0,$01980ee0
		dc.l	$01a80880,$01b00aa0,$01b80cc0
chess_scr3:	dc.l	$4801fffe,$00f00000,$00f20000
scr2:		dc.l	$5801fffe
		dc.l	$00e00000,$00e20000,$00e40000,$00e60000
chess_scr4:	dc.l	$00f00000,$00f20000
s2col:		dc.l	$018200aa,$018400cc,$018600ee
		dc.l	$01a20088,$01a400aa,$01a600cc
chess_scr5:	dc.l	$6801fffe,$00f00000,$00f20000
scr3:		dc.l	$7801fffe
		dc.l	$00e80000,$00ea0000,$00ec0000,$00ee0000
chess_scr6:	dc.l	$00f00000,$00f20000
s3col:		dc.l	$0188000a,$0190000c,$0198000e
		dc.l	$01a80008,$01b0000a,$01b8000c
chess_scr7:	dc.l	$8801fffe,$00f00000,$00f20000
scr4:		dc.l	$9801fffe
		dc.l	$00e00000,$00e20000,$00e40000,$00e60000
chess_scr8:	dc.l	$00f00000,$00f20000
s4col:		dc.l	$018200aa,$018400cc,$018600ee
		dc.l	$01a20088,$01a400aa,$01a600cc
chess_scr9:	dc.l	$a801fffe,$00f00000,$00f20000
scr5:		dc.l	$b801fffe
		dc.l	$00e80000,$00ea0000,$00ec0000,$00ee0000
chess_scr10:	dc.l	$00f00000,$00f20000
s5col:		dc.l	$01880000,$01900000,$01980000
		dc.l	$01a80000,$01b00000,$01b80000
chess_scr11:	dc.l	$c801fffe,$00f00000,$00f20000
scr6:		dc.l	$d801fffe
		dc.l	$00e00000,$00e20000,$00e40000,$00e60000
chess_scr12:	dc.l	$00f00000,$00f20000
s6col:		dc.l	$018200aa,$018400cc,$018600ee
		dc.l	$01a20088,$01a400aa,$01a600cc
chess_scr13:	dc.l	$e801fffe,$00f00000,$00f20000
scr7:		dc.l	$f801fffe
		dc.l	$00e80000,$00ea0000,$00ec0000,$00ee0000
chess_scr14:	dc.l	$00f00000,$00f20000
s7col:		dc.l	$01880000,$01900000,$01980000
		dc.l	$01a80000,$01b00000,$01b80000
palwait:	dc.l	$ffdffffe,$0607fffe,$01800000
chess_scr15:	dc.l	$fffffffe,$00f00000,$00f20000

;-------------------------------------------------
;--------------	predraw bunch of cubes -----------
fonts:		incbin	"newfont.d"
precube:	incbin	"kuutio.d"

;-------------------------------------------------
;--------------	bitplanes ------------------------
		section	planes,bss_c

chess_mask:	ds.b	lev+2
chess_gfx:	ds.b	(lev+2)*32
chess_plane1:	ds.b	(lev+2)*16*2
chess_plane2:	ds.b	(lev+2)*16*2
cube_plane1:	ds.l	lev*64
cube_plane2:	ds.l	lev*64
text_plane:	ds.w	lev*($106-$18)

;--------------	end of program -------------------
end:

